#include <stdio.h>
#include <string.h>
#include <malloc.h>
#define MAX 100

void konkaten(char ***C, char ***A, char ***B, int m, int n){
	int i, j;
	for (i=0; i<m; i++)
		for (j=0; j<n; j++) {
			C[i][j]=(char*) malloc((strlen(A[i][j])+strlen(B[i][j]))*sizeof(char));
			strcpy(C[i][j],A[i][j]);
			strcat(C[i][j],B[i][j]);			
		}
}

int main() 
{
	int i,j,m,n;
	char ***A,***B, ***C;
	char string[MAX];
	
	printf("Unesite broj redaka\n");
	scanf("%d", &m);
	printf("Unesite broj stupaca\n");
	scanf("%d", &n);
/*  Alociranje memorije  */	
	A = (char***) malloc(m*sizeof(void*));	
	for (i=0; i<m; i++) A[i]= (char**) malloc(n*sizeof(char*));
	B = (char***) malloc(m*sizeof(char*));	
	for (i=0; i<m; i++) B[i]= (char**) malloc(n*sizeof(char*));
	C = (char***) malloc(m*sizeof(char*));	
	for (i=0; i<m; i++) C[i]= (char**) malloc(n*sizeof(char*));
/*  Unos podataka    */		
	printf("Unos za matricu A\n");	
	for (i=0; i<m; i++)
		for (j=0; j<n; j++) {
			printf("Unesite rijec na mjestu (%d,%d)\n",i+1,j+1);
			scanf("%s",string); 
			A[i][j]=(char*) malloc((strlen(string))*sizeof(char));
		    strcpy(A[i][j],string);   
		}	
	printf("Unos za matricu B\n");	
	for (i=0; i<m; i++)
		for (j=0; j<n; j++) {
			printf("Unesite rijec na mjestu (%d,%d)\n",i+1,j+1);
			scanf("%s",string); 
			B[i][j]=(char*) malloc((strlen(string))*sizeof(char));
			B[i][j]=strcpy(B[i][j],string);   
		}	
		
	konkaten(C, A, B, m, n);
/* Ispisivanje rezultata */		
	for (i=0; i<m; i++)
		for (j=0; j<n; j++)
			printf("%s%s", C[i][j], (j==n-1) ? "\n" : "\t");	
/* Osobadjanje memorije  */		
	for (i=0; i<m; i++)
		for (j=0; j<n; j++)
			free(A[i][j]);			
	for (i=0; i<m; i++) free(A[i]);
	free(A);
	
	for (i=0; i<m; i++)
		for (j=0; j<n; j++)
			free(B[i][j]);
	for (i=0; i<n; i++) free(B[i]);
	free(B);
	
	for (i=0; i<m; i++)
		for (j=0; j<n; j++)
			free(C[i][j]);
	for (i=0; i<m; i++) free(C[i]);
	free(C);	
	
	return 0;
}
